local n = ...
local t = {
	{ "ItemComparison", true, "Item - Compare Items", "Auto-Compare Stats of two items"}, -- works
	{ "HidePriceOnCompare", true, "Comparison - Hide Prices", "Hide Item Price while comparing stats"}, -- works
	{ "Ench", false, "Comparison - Include Enchants", "Add item enchants to stats comparison"}, -- check
	
	{ "ItemSellPrice", true, "Item - Price", "Show Item Price on the tooltip"}, -- works
	{ "ItemLevel", true, "Item - Item Level", "Show Item Level on the tooltip"},-- works
	{ "ItemID", false, "Item - Item ID", "Show Item ID on the tooltip"}, --works
	
--	{ "UnitGuild", true, "Unit - Guild", "Show Unit's Guild on the Tooltip"}, -- disabled bcz of tbc
	{ "UnitGuid", false, "Unit - GUID", "Show Unit's Guid on the Tooltip", "GUIDs uniquely identify almost everything the player character can interact with in World of Warcraft. Read More about GUIDs on |cff00ffffwow.gamepedia.com/GUID"},
	{ "UnitTargetName", false, "Unit - Target of Target", "Show Unit's Target Name on the Tooltip"},
	
	{ "MacroBody", true, "Macro - Body", "Show Macro text on the Tooltip"}, -- works
	{ "SpellID", false, "Spell - Spell ID", "Show Spell IDs of spells"}, --
	{ "QuestInfo", true, "Unit - Quest Progress", "Show Quest Progress", "Currently works only for |n|cffffa500'Creature slain: X/Y'|r"}, -- maybe disabled
	
	{ "ClassColors", false, "Unit - Class Colors", "Players have their names and class colored with color of their class."}, -- works
	{ "GuildColor", false, "Unit - Green Guild", "Guilds in the tooltip are green."}, -- works
	{ "PvPIcons", false, "Unit - PvP Icon", "Show PvP Icon (instead of Title) before the name.", "|cffff0000Not working on TBC|r"}, -- not working
	
	{ "AllowedTooltips", {"GameTooltip","ItemRefTooltip","ShoppingTooltip1", "ShoppingTooltip2", ""},""}, 
}

local f = CreateFrame("GameTooltip", n.."MainTooltip", WorldFrame, "GameTooltipTemplate")
f:SetOwner(WorldFrame,"ANCHOR_NONE")
f:ClearLines()
f:SetText("A")
f:Show()
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:SetScript("OnEvent", function(s,e)
	s:UnregisterEvent(e)
	s:SetScript("OnEvent", nil)
	if ExtraTooltipSV then return end
	ExtraTooltipSV = {ItemCache={}}
	for _,v in pairs(t) do
		ExtraTooltipSV[v[1]] = v[2];
	end
	print("|cffffa500ExtraTooltip|r is loaded. Use slash command |cff00ffff'/ET'|r to show options. Hope you like the addon. :)") --工具提示
end)

local function SetMoneyOnTooltip()
	for _,i in ipairs(ExtraTooltipSV.AllowedTooltips) do
		local tp = _G[i]
		if tp and type(tp)=="table" and tp.GetObjectType and tp:GetObjectType()=="GameTooltip" then
			tp:SetScript("OnTooltipAddMoney", function(s,m)
				if tContains(ExtraTooltipSV.AllowedTooltips, s:GetName()) then 
					local _,link, price = s:GetItem()
					if not link then return end
					local id = tonumber(link:match("item:(%d+):"))
					
					if ExtraTooltipSV.ItemCache[id] then 
						price = select(11,unpack(ExtraTooltipSV.ItemCache[id]))
					else
						price = select(11,GetItemInfo(link))
					end 
					price = (tonumber(price) or 0) - (tonumber(m) or 0)
					if price > 0 then
						s:AddLine("Damaged Item. Sell price reduced by ".. GetCoinTextureString(price),1,0,0,1)
						--s:AddLine("Real Price: ".. GetCoinTextureString(m),1,0,0,1)
					end
				--	return 
				end 
				if not ExtraTooltipSV.ItemSellPrice then
					s:AddLine(m and m>0 and GetCoinTextureString(m) or "No sell price",1,1,1,1)
				end
			end)
		end
	end
end
f:HookScript("OnEvent", SetMoneyOnTooltip)


do 
	SLASH_EXTRATOOLTIP1 = "/extratooltip"
	SLASH_EXTRATOOLTIP2 = "/et"
	SlashCmdList["EXTRATOOLTIP"] = function(msg)
		InterfaceOptionsFrame_OpenToCategory(n)
		InterfaceOptionsFrame_OpenToCategory(n)
	end 
	StaticPopupDialogs["EXTRATOOLTIP_FEEDBACK"] = {
		text = "Any feedback appreciated. Press CTRL+X to copy website and close this window.",button1 = "Close",hasEditBox=true,timeout = 0,whileDead = true,hideOnEscape = true,preferredIndex = 3,
		OnShow = function(self)
			self.editBox:SetText("https://www.curseforge.com/wow/addons/extratooltip")
			self.editBox:HighlightText()
		end,
		EditBoxOnEscapePressed = function(self) self:GetParent().button1:Click() end,
		EditBoxOnTextChanged = function(self)
			if self:GetText():len() < 1 then
				self:GetParent().button1:Click()
			else
				self:SetText("https://www.curseforge.com/wow/addons/extratooltip")
				self:HighlightText()
			end
		end,
		}
	local f = CreateFrame("Frame", n.."OptionsFrame", UIParent)
	f.name = n
	f.okay = function() 
		for _,v in ipairs(f) do
			ExtraTooltipSV[v.var] =	v:GetChecked()
		end 
		ExtraTooltipSV.AllowedTooltips = {unpack(f.AllowedTooltipsTemp)}
		SetMoneyOnTooltip()
	end
	f.refresh = function() 
		for _,v in ipairs(f) do
			v:SetChecked(ExtraTooltipSV[v.var])
		end
		f.AllowedTooltipsTemp = {unpack(ExtraTooltipSV.AllowedTooltips)}
		f.Line0A:Disable()
		if #f.AllowedTooltipsTemp > 9 then
			f.Line0B:Disable()
			f.Line0C:SetText("You already have 10 tooltip specified and cannot add any more.")
		else
			f.Line0B:Enable()
			f.Line0B:SetScript("OnEnterPressed", function(s) f.Line0A:Click(); end)
			f.Line0B:SetScript("OnTextChanged", function(s) 
				local tp = _G[s:GetText()]
				if tContains(f.AllowedTooltipsTemp, s:GetText()) then
					f.Line0A:Disable()
					f.Line0C:SetText("You already have that tooltip.")
				elseif s:GetText()=="" then
					f.Line0A:Disable()
					f.Line0C:SetText("")
				elseif tp and type(tp)=="table" and tp.GetObjectType and tp:GetObjectType()=="GameTooltip" then
					f.Line0A:Enable()
					f.Line0C:SetText("")
				else
					f.Line0A:Disable()
					f.Line0C:SetText("Not a valid tooltip name.")
				end
			end)
			f.Line0C:SetText("")
		end
		f.semiRefresh()
	end
	f.semiRefresh = function()
		for k=1,10 do
			if f.AllowedTooltipsTemp[k] then
				f["Line"..k.."A"]:Show()
				f["Line"..k.."B"]:Show()
				f["Line"..k.."B"]:SetText(f.AllowedTooltipsTemp[k]) 
				local tp = _G[f.AllowedTooltipsTemp[k]]
				if tp and type(tp)=="table" and tp.GetObjectType and tp:GetObjectType()=="GameTooltip" then
					f["Line"..k.."C"]:Hide()
					if not tContains (ExtraTooltipSV.AllowedTooltips, tp:GetName()) then
						f["Line"..k.."C"]:Show()
						f["Line"..k.."C"]:SetText("( Will be added when you click [Okay] button below )")
					end
				else
					f["Line"..k.."C"]:Show()
					f["Line"..k.."C"]:SetText("(Warning: Not a valid tooltip.)")
				end
			else
			f["Line"..k.."A"]:Hide()
			f["Line"..k.."B"]:Hide()
			f["Line"..k.."C"]:Hide()
			end
		end
	end
	
	InterfaceOptions_AddCategory(f)
	
	local feedback = CreateFrame("Button", f:GetName().."FeedbackButton",f,"GameMenuButtonTemplate")
	feedback:SetPoint("BOTTOMRIGHT", -10, 10)
	feedback:SetSize(125, 25)
	feedback:SetText("Feedback") 
	feedback:SetScript("OnClick", function() StaticPopup_Show("EXTRATOOLTIP_FEEDBACK") end)
	
	local about = f:CreateFontString(nil,nil,"GameFontHighlightSmall")
	about:SetPoint("RIGHT", feedback, "LEFT")
	about:SetText(n .. format(" v%s ", GetAddOnMetadata(n, "version")))
	
	local fnt = f:CreateFontString(f:GetName().."Title", "ARTWORK", "GameFontNormalLarge") -- HelpFrame, HelpBrowser
	fnt:SetJustifyH("LEFT")
	fnt:SetJustifyV("TOP")
	fnt:SetPoint("TOPLEFT", 16,-16)
	fnt:SetText("Extra Tooltip")
	local fnt = f:CreateFontString(f:GetName().."SubText", "ARTWORK", "GameFontHighlightSmall")
	fnt:SetJustifyH("LEFT")
	fnt:SetJustifyV("TOP")
	fnt:SetMaxLines(3)
	fnt:SetNonSpaceWrap(true)
	fnt:SetSize(32,0)
	fnt:SetPoint("TOPLEFT", f:GetName().."Title", "BOTTOMLEFT", 0,-8)
	fnt:SetPoint("RIGHT",-32,0)
	fnt:SetText("These controls affect what extra informations are shown on ingame tooltips. Infromations such as <Guild>, item level and ID, spell ID, etc.")
	do local b 
		for k,v in pairs(t) do
			if type(v[2]) == "boolean" then
				b = CreateFrame("CheckButton", "CheckButton"..k, f)
				f[k] = b 
				f[k].var = v[1]
				b:SetPoint("TOPLEFT", fnt, "BOTTOMLEFT", 185*((k-1)%3),  -1 - math.floor((k-1)/3)* 30)
				b:SetSize(26,26)
				b:SetHitRectInsets(0,-100,0,0)
				b:SetNormalTexture("Interface/Buttons/UI-CheckBox-Up")
				b:SetPushedTexture("Interface/Buttons/UI-CheckBox-Down")
				b:SetCheckedTexture("Interface/Buttons/UI-CheckBox-Check")
				b:SetDisabledTexture("Interface/Buttons/UI-CheckBox-Check-Disabled")
				b:SetHighlightTexture("Interface/Buttons/UI-CheckBox-Highlight", "ADD")
				b.t = b:CreateFontString(b:GetName().."Text", "ARTWORK", "GameFontNormal")
				b.t:SetPoint("LEFT", b, "RIGHT",1,0)
				b.t:SetText(v[3])
				b:SetScript("OnEnter", function(s)
					GameTooltip:SetOwner(s, "ANCHOR_RIGHT")
					GameTooltip:SetText(v[4])
					if v[5] then GameTooltip:AddLine(v[5],1,1,1,1) end
					GameTooltip:Show()
				end)
				b:SetScript("OnLeave", function() GameTooltip:Hide() end)
				b:SetScript("OnClick", function(s) PlaySound(s:GetChecked() and SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON or SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF ) end)
			elseif type(v[2]) == "table" then
				local fnt = f:CreateFontString(f:GetName().."SubText2", "ARTWORK", "GameFontNormal")
				fnt:SetJustifyH("LEFT")
				fnt:SetJustifyV("TOP")
				fnt:SetPoint("LEFT",16, -32)
				fnt:SetPoint("TOP",b,"BOTTOM", 0, -20)
				fnt:SetText("Allowed Tooltips")
		
				local fnt2 = f:CreateFontString(f:GetName().."SubText3", "ARTWORK", "GameFontHighlightSmall")
				fnt2:SetJustifyH("LEFT")
				fnt2:SetJustifyV("TOP")
				fnt2:SetPoint("TOPLEFT",fnt,"BOTTOMLEFT", 0, -8)
				fnt2:SetText("Only tooltips listed here have their appearance changed. You can add your own tooltips here or remove default tooltips. You can have up to 10 different tooltips specified.")
				fnt2:SetMaxLines(3)
				fnt2:SetNonSpaceWrap(true)
				fnt2:SetSize(0, 32)
				fnt2:SetPoint("RIGHT", -32, 0)
				
				local p = CreateFrame("Button", nil, f)
				f.Line0A = p
				p:SetPoint("TOPLEFT", fnt2, "BOTTOMLEFT", 0, -6)
				p:SetSize(15,15)
				p:SetNormalTexture("Interface/Buttons/UI-PlusButton-Up")
				p:SetPushedTexture("Interface/Buttons/UI-PlusButton-Down")
				p:SetHighlightTexture("Interface/Buttons/UI-PlusButton-Hilight", "ADD")
				p:SetDisabledTexture("Interface/Buttons/UI-PlusButton-Disabled")
				p:SetScript("OnClick", function() table.insert(f.AllowedTooltipsTemp, f.Line0B:GetText()); f.Line0B:SetText(""); f.semiRefresh();  end)
				p:Disable()
				
				local editBox = CreateFrame("EditBox", nil, p, "InputBoxTemplate")
				f.Line0B = editBox
				editBox:SetPoint("TOPLEFT", p, "TOPRIGHT", 15, 0)
				editBox:SetAutoFocus(false)
				editBox:SetSize(200, 15)
				editBox:Disable()
				
				p:HookScript("OnClick", function() editBox:ClearFocus() end)
				
				local fnt = f:CreateFontString(f:GetName().."SubSubText1", "ARTWORK", "GameFontHighlightSmall")
				f.Line0C = fnt 
				fnt:SetPoint("TOPLEFT", editBox, "TOPRIGHT", 15, -1)
				fnt:SetText("Disabled text")
				fnt:SetTextColor(1,0,0)
				
				for x = 1,10 do
					f["Line"..x.."A"] = CreateFrame("Button", nil, f, "UIPanelCloseButtonNoScripts", x)
					f["Line"..x.."A"]:SetPoint("TOPLEFT", f["Line"..(x-1).."A"], "BOTTOMLEFT", 0,-2) 
					f["Line"..x.."A"]:SetSize(20,20)
					f["Line"..x.."A"]:SetScript("OnClick", function(s) table.remove(f.AllowedTooltipsTemp, s:GetID()) f.semiRefresh() end)
					
					f["Line"..x.."B"] = f:CreateFontString(nil, "ARTWORK", "GameFontNormal")
					f["Line"..x.."B"]:SetPoint("TOPLEFT", f["Line"..x.."A"], "TOPRIGHT",4,-4)
					f["Line"..x.."B"]:SetText("Line "..x)
					
					local fnt = f:CreateFontString(f:GetName().."SubSubText1", "ARTWORK", "GameFontHighlightSmall")
					f["Line"..x.."C"] = fnt 
					fnt:SetPoint("TOPLEFT", f["Line"..x.."B"], "TOPRIGHT",7,0)
					fnt:SetText("(Sub Line"..x..")")
					fnt:SetTextColor(1,0,0)
				end
			else
				return error("Unknown Option Format") --►
			end
		end
	end
end 

local mt = getmetatable(f).__index
local frame = CreateFrame("Frame")
local function TooltipIsAllowed(tooltip)
	return tooltip:GetName() and tContains(ExtraTooltipSV.AllowedTooltips, tooltip:GetName()) 
end 

local function TooltipInsertLine(s,position,line,r,g,b)
	position = tonumber(position) or 2
	s:AddLine("Arkoniel is the best!",1,1,1,1)
	for x=(s:NumLines()), (position+1), -1 do
		_G[s:GetName().."TextLeft"..x]:SetText(_G[s:GetName().."TextLeft"..(x-1)]:GetText())
		_G[s:GetName().."TextLeft"..x]:SetTextColor(_G[s:GetName().."TextLeft"..(x-1)]:GetTextColor())
		_G[s:GetName().."TextLeft"..x]:SetWidth(_G[s:GetName().."TextLeft"..(x-1)]:GetWidth())
		_G[s:GetName().."TextRight"..x]:SetText(_G[s:GetName().."TextRight"..(x-1)]:GetText())
		_G[s:GetName().."TextRight"..x]:SetTextColor(_G[s:GetName().."TextRight"..(x-1)]:GetTextColor())
		_G[s:GetName().."TextRight"..x]:SetShown(_G[s:GetName().."TextRight"..(x-1)]:IsShown())		
	end
	_G[s:GetName().."TextRight"..position]:SetText(nil)
	_G[s:GetName().."TextRight"..position]:Hide()
	_G[s:GetName().."TextLeft"..position]:SetText(line)
	_G[s:GetName().."TextLeft"..position]:SetTextColor(r or 1, g or 1, b or 1, 1)
	for x=1,s.shownMoneyFrames or 0 do
		local money = _G[s:GetName().."MoneyFrame"..x]
		local a,b,c,d,e = money:GetPoint()
		money:SetPoint(a,_G[(b:GetName()):gsub("%d+", function(i) return tonumber(i)<position and i or (i+1) end)],c,d,e)
	end
end
local function TooltipSetItem(tooltip, num, compare)
	if not TooltipIsAllowed(tooltip) then return end
	num = tonumber(num) or 1
	
	local _,link,n,ilvl,weapon,loc,price = tooltip:GetItem()
	if not link then return end
	local id = tonumber(link:match("item:(%d+):"))
	
	if ExtraTooltipSV.ItemCache[id] then 
		n,_,_,ilvl,_,_,weapon,_,loc,_,price = unpack(ExtraTooltipSV.ItemCache[id]) -- this is preferred..
	else
		n,_,_,ilvl,_,_,weapon,_,loc,_,price = GetItemInfo(link);
	end
	local type = (loc == "INVTYPE_RANGEDRIGHT") and weapon:sub(1,-2) or _G[loc];
	if ilvl and  ExtraTooltipSV.ItemLevel and type then
		for i=1,tooltip:NumLines() do
		if _G[tooltip:GetName().."TextLeft"..i]:GetText()== type then
			TooltipInsertLine(tooltip, i, format("Item Level %s",ilvl),1,222/255,0,1)
			break
		end
	end 
	end
	if price and (price*num) > 0 and ExtraTooltipSV.ItemSellPrice and (not compare or not ExtraTooltipSV.HidePriceOnCompare) then 
		tooltip:AddLine("Sell Price:  ".. GetCoinTextureString(price*num),1,1,1)
	end
	if ExtraTooltipSV.ItemID then
		tooltip:AddLine("Item ID: "..id,255/255,222/255,0,1)
	end
	tooltip:Show()
end

local function TooltipSetUnit(tooltip, unit)
	local name, from = tooltip:GetUnit() 
	if not TooltipIsAllowed(tooltip) or not name or not from then return end
	local guild, rank, rankID = GetGuildInfo(unit)
	local guid, class, class2 = UnitGUID(unit), UnitClass(from);
	local colors = RAID_CLASS_COLORS[class2]
	local title,icon = GetPVPRankInfo(UnitPVPRank(from))
	if ExtraTooltipSV.PvPIcons and icon and icon > 0 then
		_G[tooltip:GetName().."TextLeft1"]:SetText(gsub(_G[tooltip:GetName().."TextLeft1"]:GetText(), title:gsub("%W","%%%1"), format("|TInterface\\PvPRankBadges\\PvPRank%02d:0|t", icon)))
	end
	if ExtraTooltipSV.ClassColors and colors and UnitPlayerControlled(unit) then
		_G[tooltip:GetName().."TextLeft1"]:SetText("|c".. (colors.colorStr) .. (_G[tooltip:GetName().."TextLeft1"]:GetText()) .. "|r")
		for x=2,3,1 do
			if not _G[tooltip:GetName().."TextLeft"..x]:GetText() then break end
			_G[tooltip:GetName().."TextLeft"..x]:SetText(gsub(_G[tooltip:GetName().."TextLeft"..x]:GetText(),class, "|c".. (colors.colorStr) .."%1|r"))
		end
	end
	if guild then --and ExtraTooltipSV.UnitGuild then 
		if not (_G[tooltip:GetName().."TextLeft2"]:GetText() == guild) then
			TooltipInsertLine(tooltip, 2, "GUILD");
		end
		_G[tooltip:GetName().."TextLeft2"]:SetText((rankID==0 and "|TInterface\\GroupFrame\\UI-Group-LeaderIcon:16|t " or "" ).. guild)
		if ExtraTooltipSV.GuildColor then
			_G[tooltip:GetName().."TextLeft2"]:SetTextColor(0,1,0)
		end
		--TooltipInsertLine(tooltip, 2, (rankID==0 and "|TInterface\\GroupFrame\\UI-Group-LeaderIcon:16|t " or "" ).. guild ,ExtraTooltipSV.GuildColor and 0 or 1,1,ExtraTooltipSV.GuildColor and 0 or 1)
	end
	if guid and ExtraTooltipSV.UnitGuid then
		tooltip:AddLine("Guid: "..guid, 236/255, 66/255, 245/255)
	end
	if ExtraTooltipSV.UnitTargetName and UnitName(unit.."target") then
		tooltip:AddLine(format("Targeting: %s", UnitName(unit.."target") or "<No Target>"),0,215/255,190/255)
	end
	if guid and ExtraTooltipSV.QuestInfo and frame and frame.Quests and frame.Quests[name] then
		tooltip:AddLine(" ")
		tooltip:AddLine(frame.Quests[name][1])
		tooltip:AddLine(frame.Quests[name][2],1,1,1,1)
	end
	tooltip:Show()
	return
end



frame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
frame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
frame:RegisterEvent("QUEST_LOG_UPDATE")
frame:SetScript("OnEvent", function(s,e,id,t)
	if e == "UPDATE_MOUSEOVER_UNIT" and GetMouseFocus()==WorldFrame and UnitExists("mouseover") then
		TooltipSetUnit(GameTooltip, "mouseover");
		return
	end
	if e == "GET_ITEM_INFO_RECEIVED" and t == true then
		ExtraTooltipSV.ItemCache[id] = { GetItemInfo(id) } 
		for k,v in pairs(ExtraTooltipSV.AllowedTooltips) do 
			local tp = _G[v] 
			if tp then
				local item, link = tp:GetItem()
				if tp:IsShown() and link and link:match("item:"..id) then
					TooltipSetItem(tp)
				end
			end
		end
		return
	end 
	if e == "QUEST_LOG_UPDATE" then
		s.Quests = {}
		for i=1,GetNumQuestLogEntries(),1 do 
			local quest,_,_,header = GetQuestLogTitle(i)
			if not header then
				for index = 1,GetNumQuestLeaderBoards(i),1 do
					local text = GetQuestLogLeaderBoard(index,i)
					local npc = (text or ""):match("^([%w%' ]+) [sS]lain%: %d+%/%d+$") --or text:match("^([%w%' ]+)%: %d+%/%d+$")
					if npc then
						s.Quests[npc] = {quest,text};
					end
				end
			end
		end
	end
end)
hooksecurefunc("UnitFrame_UpdateTooltip", function(tbl) 
	TooltipSetUnit(GameTooltip, tbl.unit) 
end) 

hooksecurefunc(mt, "SetHyperlink", function(s,link)
	local type, id = link:match("H?(%a+):(%d+):")
	if type == "spell" and ExtraTooltipSV.SpellID then
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
		return
	end
	if type == "item" then
		TooltipSetItem(s)
	end
end)
hooksecurefunc(mt, "SetAction", function(s,a)
	if not (TooltipIsAllowed(s)) then return end
	local t, id = GetActionInfo(a)
	if t=="macro" and ExtraTooltipSV.MacroBody then 
		s:AddLine(GetMacroBody(id),166/255, 166/255, 166/255,true);
		s:Show()
		return
	end
	if t=="spell" and ExtraTooltipSV.SpellID then 
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
		return
	end
	if t=="item" then 
		TooltipSetItem(s, GetItemCount(id))
	end
end)
hooksecurefunc(mt, "SetUnitAura", function(s,u,i,f)
	if (TooltipIsAllowed(s)) and ExtraTooltipSV.SpellID then
		local _,_,_,_,_,_,_,_,_,id = UnitAura(u,i,f)
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
	end
end)
hooksecurefunc(mt, "SetUnitDebuff", function(s,u,i)
	if (TooltipIsAllowed(s)) and ExtraTooltipSV.SpellID then
		local _,_,_,_,_,_,_,_,_,id = UnitDebuff(u,i)
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
	end
end)
hooksecurefunc(mt, "SetUnitBuff", function(s,u,i)
	if (TooltipIsAllowed(s)) and ExtraTooltipSV.SpellID then
		local _,_,_,_,_,_,_,_,_,id = UnitBuff(u,i)
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
	end
end)
hooksecurefunc(mt, "SetSpellBookItem", function(s,id,b)
	local _,id = GetSpellBookItemInfo(id,b)
	if id and ExtraTooltipSV.SpellID then 
		s:AddLine("Spell ID: "..id,192/255,215/255,215/255,1)
		s:Show()
		return
	end
end)
hooksecurefunc(mt, "SetBuybackItem", function(s,index)
	local n,_,_,q = GetBuybackItemInfo(index)
	if n then TooltipSetItem(s,q or 1) end
end)
hooksecurefunc(mt, "SetQuestItem", function(s,t,a)
	local name, _, c = GetQuestItemInfo(t,a)
	TooltipSetItem(s,c or 1)
end)
hooksecurefunc(mt, "SetQuestLogItem", function(s,t,a)
	local _,n
	if t == "reward" then  
		_,_,n = GetQuestLogRewardInfo(tonumber(a))
	end 
	TooltipSetItem(s,n or 1)
end)
hooksecurefunc(mt, "SetTradePlayerItem", function(s,x)
	local _,_,c = GetTradePlayerItemInfo(x)
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetTradeTargetItem", function(s,x)
	local _,_,c = GetTradeTargetItemInfo(x)
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetLootItem", function(s,x)
	local _,_,c = GetLootSlotInfo(x)
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetInboxItem", function(s,x,y)
	y=y or 1
	local _,_,_,c = GetInboxItem(x,y)
	TooltipSetItem(s,c); 
end)
hooksecurefunc(mt, "SetSendMailItem", function(s,x)
	local _,_,_,c = GetSendMailItem(x)
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetAuctionSellItem", function(s)
	local _,_,c = GetAuctionSellItemInfo()
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetAuctionItem", function(s,x,y)
	local _,_,c = GetAuctionItemInfo(x,y)
	TooltipSetItem(s,c)
end)
hooksecurefunc(mt, "SetBagItem", function(s,x,y)
	local _,c = GetContainerItemInfo(x,y)
	TooltipSetItem(s,c)
end)
for _,v in pairs({"SetInventoryItem", "SetMerchantItem"}) do
	hooksecurefunc(mt, v, function(s) TooltipSetItem(s) end)
end

local set = "äöüÄÖÜßáéíóúüñ¿¡ÁÉÍÓÚÜÑÇâêîôûàèùëïü"
hooksecurefunc(mt, "SetCompareItem", function(sh1,sh2,s)
	if not ExtraTooltipSV.ItemComparison then 
		for _, tooltip in pairs({sh1,sh2}) do
			TooltipSetItem(tooltip, 1, 1) 
		end
		return  
	end 
		
	for _, tooltip in pairs({sh1,sh2}) do
		if not tooltip:IsShown() then break end 
		local tbl = {}
		
		for num, tooltip2 in pairs({[-1]=tooltip, [1]=tooltip:GetOwner()}) do --print(s:GetName(), tooltip:GetOwner():GetName() ) -- tooltip:GetOwner == s ?
			local _, itemLink = tooltip2:GetItem()
			if not ExtraTooltipSV.Ench then
				itemLink = itemLink:gsub("item:(%d+):%d+:", "item:%1::")
			end
			f:ClearLines() -- Healing and Spell Damage +X/Spell Hit +X%
			f:SetHyperlink(itemLink)
			for i=3, f:NumLines() do --- num lines here or multiple line .. 
			 	local post, value, stat, spell, value2 = "" -- post is for percentage stats, spell is for (spell crit, spell hit and spell damage )
				local text = _G[f:GetName().."TextLeft".. i]:GetText()
				text = text:match("^|cffffffff([%w%+%-%% "..  set.."]+)|r$") or text
				text = text:gsub(" de ", " ") -- de removed :D
				value, post, stat = text:match("^([%+%-]?[%d]+)(%%?) ([%a%d "..  set .."]+)%.?$") -- -15(%) arcane resistance
				if not (value and stat) then
					value, stat = text:sub(2,-2):match("^([%+%-]?[%d%.]+) ([%w "..  set .."]+)$") -- (3.14 damage per seconds)
				end
				if not (value and stat) then
					stat, value = text:match("(Armure) : (%d+)")
				end
				if not (value and stat) then
					stat, value = text:match("^Equip%: Increased ([%a%d ]+) ([%+%-]?[%d]+)%.$") -- Equip: Increased Something +X. (Daggers +5, Defense +2.. etc)
				end
				if not (value and stat) then
					value, stat = text:match("^Equip%: ([%+%-]?[%d]+) ([%a%d ]+)%.$") -- Equip: +3 Attack Power
				end
				if not (value and stat) then
					value = text:match("^Equip%: Increases healing done by spells and effects by up to (%d+)%.$") 
					if value then stat = "Healing Spells" end
				end
				if not (value and stat) then
					stat, value, post = text:match("^Equip%: Increases damage done by (%a* ?)spells and effects by up to (%d+)(%%?)%.$")
					if stat	then stat = stat .. "Spell Damage" end
				end
				if not (value and stat) then
					stat, value, post = text:match("^Equip%: Increases the critical effect chance of your (%a* ?)spells by (%d+)(%%?)%.$")
					if stat then stat = stat.."Spell Crit" end
				end
				-- NEW IN TBC
				if not (value and stat) then 
					stat, value = text:match("^Equip%: Increases ([%a ]* ?) rating by (%d+)%.$")
				end
				if not (value and stat) then 
					stat, value = text:match("^Equip%: Increases ([%a ]* ?) by (%d+)%.$")
				end
				if not (value and stat) then 
					stat, value = text:match("^Equip%: Improves ([%a ]* ?) rating by (%d+)%.$")
				end
				if not (value and stat) then 
					stat, value, value2 = text:match("^Equip%: Increases (healing done by) up to (%d+) and damage done by up to (%d+) for all magical spells and effects%.$")
				end
				-- NEW IN TBC ^
				if not (value and stat) then
					stat, spell, value, post = text:match("^Equip%: Improves your chance to (hit) ([%w ]-)by (%d+)(%%?)%.$")
				end
				if not (value and stat) then
					stat, spell, value, post = text:match("^Equip%: Improves your chance to get a (crit)ical strike ([%w ]-)by (%d+)(%%?)%.$")
				end
				if not (value and stat) then
					stat, value, post = text:match("^Equip%: Increases the (block value) of your shield by (%d+)(%%?)%.$")
				end
				if not (value and stat) then
					stat, value, post = text:match("^Equip%: Increases your chance to (block) attacks with a shield by (%d+)(%%?)%.$")
					if stat then stat = "Block Chance" end
				end
				if not (value and stat) then
					stat, value, post = text:match("^Equip%: Increases your chance to (%w+) an attack by (%d+)(%%?)%.$")
				end
				if not (value and stat) then
					value, stat = text:match("^Equip%: Restores (%d+) (%w+ per 5 sec).")
				end
				if not (value and stat) then 
					value, post, stat = text:match("Counterweight %+(%d+)(%%?) ([%w ]+)$")
				end
				
				if not (value and stat) then -- simple enchant -- might be: stat == "Healing and Spell Damage"
					stat, value, post = text:match("^([%w "..  set .."]+) (+%d+)(%%?)$")
				end
				if not (value and stat) then
					stat, value = text:match("^Equip%: Increases (damage and healing done) by magical spells and effects by up to (%d+)%.$")
				end
				
				
				if stat == "Healing and Spell Damage" or stat == "damage and healing done" or stat == "Spell Damage and Healing" then -- multiple enlish stats
					tbl["Healing Spells"] = (tbl["Healing Spells"] or 0) + tonumber(value) * (num)
					tbl["Spell Damage"] = (tbl["Spell Damage"] or 0) + tonumber(value) * (num)
				elseif value and value2 and stat == "healing done by" then
					tbl["Healing Spells"] = (tbl["Healing Spells"] or 0) + tonumber(value) * (num)
					tbl["Spell Damage"] = (tbl["Spell Damage"] or 0) + tonumber(value2) * (num)
				elseif (value and stat) then
					if stat:sub(1,5) == "your " then stat = stat:sub(6) end
					stat = stat:gsub(".", string.upper, 1) 
					stat = stat:gsub(" %a", string.upper) 
					if stat == "HP" then stat = "Health" end
					if stat == "Block" then stat = "Block Rating" end -- changed value to rating..
					if stat == "Reinforced Armor" then stat = "Armor" end
					if spell and spell == "with spells " then
						stat = "Spell "..stat
					end
					if post and post == "%" then stat = stat .. "%" end
					tbl[stat] = (tbl[stat] or 0) + tonumber(value) * (num)
				elseif text:match("/") then -- multiple stats
					for key in string.gmatch(text, "[^%/]+") do
						stat, value, post = key:match("^([%w ]+) (+%d+)(%%?)$")
						if value and stat then 
							if stat and stat == "Mana Regen" then stat = "Mana per 5 sec" end
							if post and post == "%" then stat = stat .. "%" end
							tbl[stat] = (tbl[stat] or 0) + tonumber(value) * (num)
						end
					end
				else
					
				
				
				end
			end
		end
		TooltipSetItem(tooltip, 1, 1) -- Stats are scanned, we can add our own lines now.
		for k,v in pairs(tbl) do
			v = tonumber(v) or error(format("ExtraTooltip error on comparing items: [%s]=%s",k,v),1)
			if v>0 or v<0 then 
				tooltip:AddLine(" ")
				tooltip:AddLine("If you replace this item, the following stat |nchanges will occur:",255/255,211/255,0)
				break
			end
		end
		for k,v in pairs(tbl) do
			local p = tostring(k):match("%%")
			v = tonumber(tostring(v):match("[%d%+%-%.]+"))
			if not ( v == 0 ) then
				tooltip:AddLine((v>0 and "+"..v or v)..(p and "% " or " ").. "|cffffffff"..(k:match("[%w%. "..set.."]+")), (v<0) and 1 or 0, (v>0) and 1 or 0,0)
			end
		end
	tooltip:Show()
	end
end)


